

local frozen = false
local unfrozen = false
local freeze = false
function tvRP.loadFreeze(freeze)
    freeze = not freeze
    frozen = true
end


function tvRP.spawnVehicle(model) 
    -- load vehicle model
    local i = 0
    local mhash = GetHashKey(model)
    while not HasModelLoaded(mhash) and i < 1000 do
	  	if math.fmod(i,100) == 0 then
	  	  tvRP.notify("Modelul vehiculului se incarca")
	  	end
      	RequestModel(mhash)
      	Citizen.Wait(30)
	  	i = i + 1
    end

    if HasModelLoaded(mhash) then
      	local x,y,z = tvRP.getPosition({})
      	local nveh = CreateVehicle(mhash, x,y,z+0.5, GetEntityHeading(PlayerPedId()), true, false)
      	SetVehicleOnGroundProperly(nveh)
      	SetEntityInvincible(nveh,false)
      	SetPedIntoVehicle(PlayerPedId(),nveh,-1)
      	Citizen.InvokeNative(0xAD738C3085FE7E11, nveh, true, true)
      	SetVehicleHasBeenOwnedByPlayer(nveh,true)
      	SetModelAsNoLongerNeeded(mhash)
	  	tvRP.notify("Vehicul spawnat cu succes")
	else
        tvRP.notify("Model vehicul invalid",2)
	end
end

function tvRP.getArmour()
  	return GetPedArmour(PlayerPedId())
end

function tvRP.setArmour(armour, vest)
	local ped = PlayerPedId()
	if vest then
		RequestAnimDict("clothingtie")
	  while not HasAnimDictLoaded("clothingtie") do
		  Citizen.Wait(1) 
	  end
	  TaskPlayAnim(ped, "clothingtie", "try_tie_negative_a", 3.0, 3.0, 2000, 01, 0, false, false, false)
		if(GetEntityModel(player) == GetHashKey("mp_m_freemode_01")) then
			SetPedComponentVariation(player, 9, 26, 9, 0)
		else 
			if(GetEntityModel(player) == GetHashKey("mp_f_freemode_01")) then
			SetPedComponentVariation(ped, 9, 6, 1, 2)
			end
	  	end
	end
	local n = math.floor(armour)
	SetPedArmour(ped, n)
end

local function teleportToWaypoint()
	local targetPed = PlayerPedId()
	local targetVeh = GetVehiclePedIsUsing(targetPed)
	if(IsPedInAnyVehicle(targetPed))then
		targetPed = targetVeh
    end

	if(not IsWaypointActive())then
		tvRP.notify("Nu sa gasit un checkpoint",2)
		return
	end

	local waypointBlip = GetFirstBlipInfoId(8) -- 8 = waypoint Id
	local x,y,z = table.unpack(Citizen.InvokeNative(0xFA7C7F0AADF25D09, waypointBlip, Citizen.ResultAsVector())) 

	local ground
	local groundFound = false
	--local groundCheckHeights = {100.0, 150.0, 50.0, 0.0, 200.0, 250.0, 300.0, 350.0, 400.0,450.0, 500.0, 550.0, 600.0, 650.0, 700.0, 750.0, 800.0}

	for height = 0, 800, 2 do
		SetEntityCoordsNoOffset(targetPed, x,y,height+0.0001, 0, 0, 1)
		Wait(10)

		ground,z = GetGroundZFor_3dCoord(x,y,height+0.0001)
		if(ground) then
			z = z + 1
			groundFound = true
			break;
		end
	end

	if(not groundFound)then
		z = 1000
		GiveDelayedWeaponToPed(PlayerPedId(), 0xFBAB5776, 1, 0) -- parachute
	end

	SetEntityCoordsNoOffset(targetPed, x,y,z, 0, 0, 1)
	tvRP.notify("Te-ai teleportat la checkpoint")
end
RegisterNetEvent("TpToWaypoint")
AddEventHandler("TpToWaypoint", teleportToWaypoint)

other = nil
drag = false
playerStillDragged = false

RegisterNetEvent("dr:drag")
AddEventHandler('dr:drag', function(pl)
    other = pl
    drag = not drag
end)

RegisterNetEvent("dr:undrag")
AddEventHandler('dr:undrag', function(pl)
	if(other == pl)then
		other = nil
		drag = false
	end
end)

Citizen.CreateThread(function()
    while true do
        Wait(2000)
        while drag and other ~= nil do
            Wait(0)
            local ped = GetPlayerPed(GetPlayerFromServerId(other))
            local myped = PlayerPedId()
            --AttachEntityToEntity(myped, ped, 4103, 11816, 0.48, 0.00, 0.0, 0.0, 0.0, 0.0, false, false, false, false, 2, true)
            AttachEntityToEntity(myped, ped, 11816, 0.44, 0.44, 0.0, 0.0, 0.0, 0.0, false, false, false, false, 2, true)
            playerStillDragged = true
        end

        if playerStillDragged then
            DetachEntity(PlayerPedId(), true, false)
            playerStillDragged = false
        end
    end
end)

local radarEsteso = false
local mostrablip = false
local mostranomi = false

RegisterNetEvent('mostraBlips')
AddEventHandler('mostraBlips', function()
    mostrablip = not mostrablip
    if mostrablip then
        mostrablip = true
        -- notifica blips abilitati
     --   TriggerEvent('chatMessage', 'Blips', {0, 255, 0}, "Activat.")
    else
        mostrablip = false
        -- notifica blips disabilitati
       -- TriggerEvent('chatMessage', 'Blips', {255, 0, 0}, "Dezactivat.")
    end
end)

RegisterNetEvent('mostraNomi')
AddEventHandler('mostraNomi', function()
    mostranomi = not mostranomi
    if mostranomi then
        mostranomi = true
        -- notifica blips abilitati
        TriggerEvent('chatMessage', 'Names', {0, 255, 0}, "Activat.")
    else
        mostranomi = false
        -- notifica blips disabilitati
        TriggerEvent('chatMessage', 'Names', {255, 0, 0}, "Dezactivat.")
    end
end)

Citizen.CreateThread(function()
    while true do
    
    -- controllo del giocatore, se esiste e ha un id.
    while mostrablip do
        Wait(1)
                for i = 0, 255 do
            
                        if NetworkIsPlayerActive(i) and GetPlayerPed(i) ~= PlayerPedId() then
                            ped = GetPlayerPed(i)
                            blip = GetBlipFromEntity(ped)
                            -- Crea il nome sulla testa del giocatore
                            idTesta = Citizen.InvokeNative(0xBFEFE3321A3F5015, ped, GetPlayerName(i), false, false, "", false)

                            if mostranomi then
                                Citizen.InvokeNative(0x63BB75ABEDC1F6A0, idTesta, 0, true) -- Aggiunge il nome de giocatore sulla testa
                                -- Mostra se il giocatore sta parlando.
                                if NetworkIsPlayerTalking(i) then
                                    Citizen.InvokeNative(0x63BB75ABEDC1F6A0, idTesta, 9, true)
                                else
                                    Citizen.InvokeNative(0x63BB75ABEDC1F6A0, idTesta, 9, false)
                                end
                            else -- Rimuove tutti i blip se mostranomi = false
                                Citizen.InvokeNative(0x63BB75ABEDC1F6A0, idTesta, 9, false)
                                Citizen.InvokeNative(0x63BB75ABEDC1F6A0, idTesta, 0, false)
                            end

                            if mostrablip then
                                if not DoesBlipExist(blip) then -- Con questo aggiungo i blip sulla testa dei giocatori.
                                    blip = AddBlipForEntity(ped)
                                    SetBlipSprite(blip, 1) -- imposto il blip sulla posizione "blip" con l'id 1
                                    Citizen.InvokeNative(0x5FBCA48327B914DF, blip, true) -- Aggiunge effettivamente il blip
                                else -- se il blip esiste, allora lo aggiorno
                                    veh = GetVehiclePedIsIn(ped, false) -- questo lo uso per aggiornare ogni volta il veicolo su cui il ped è salito
                                    blipSprite = GetBlipSprite(blip)
                                    if not GetEntityHealth(ped) then -- controllo se il giocatore è morto o no
                                        if blipSprite ~= 274 then
                                            SetBlipSprite(blip, 274)
                                            Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Aggiunge effettivamente il blip
                                        end
                                    elseif veh then -- controllo se il giocatore è su un veicolo.
                                        calsseVeicolo = GetVehicleClass(veh)
                                        modelloVeicolo = GetEntityModel(veh)
                                        if calsseVeicolo == 15 then -- La classe 15 indica un veicolo volante
                                            if blipSprite ~= 422 then -- controllo se il blip non è il 422, ovvero l'aereo
                                                SetBlipSprite(blip, 422) -- se true lo imposto.
                                                Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Aggiunge effettivamente il blip
                                            end
                                        elseif calsseVeicolo == 16 then -- controllo se il ped sta su un aereo
                                            if modelloVeicolo == GetHashKey("besra") or modelloVeicolo == GetHashKey("hydra") or modelloVeicolo == GetHashKey("lazer") then -- controllo se il modello è un jet militare
                                                if blipSprite ~= 424 then
                                                    SetBlipSprite(blip, 424)
                                                    Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Aggiunge effettivamente il blip
                                                end
                                            elseif blipSprite ~= 423 then
                                                SetBlipSprite(blip, 423)
                                                Citizen.InvokeNative (0x5FBCA48327B914DF, blip, false) -- Aggiunge effettivamente il blip
                                            end
                                        elseif calsseVeicolo == 14 then -- boat
                                            if blipSprite ~= 427 then
                                                SetBlipSprite(blip, 427)
                                                Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Aggiunge effettivamente il blip
                                            end
                                        elseif modelloVeicolo == GetHashKey("insurgent") or modelloVeicolo == GetHashKey("insurgent2") or modelloVeicolo == GetHashKey("limo2") then
                                                if blipSprite ~= 426 then
                                                    SetBlipSprite(blip, 426)
                                                    Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Aggiunge effettivamente il blip
                                                end
                                            elseif modelloVeicolo == GetHashKey("rhino") then -- tank
                                                if blipSprite ~= 421 then
                                                    SetBlipSprite(blip, 421)
                                                    Citizen.InvokeNative(0x5FBCA48327B914DF, blip, false) -- Aggiunge effettivamente il blip
                                                end
                                            elseif blipSprite ~= 1 then -- default blip
                                                SetBlipSprite(blip, 1)
                                                Citizen.InvokeNative(0x5FBCA48327B914DF, blip, true) -- Aggiunge effettivamente il blip
                                            end
                                            -- Show number in case of passangers
                                            passengers = GetVehicleNumberOfPassengers(veh)
                                            if passengers then
                                                if not IsVehicleSeatFree(veh, -1) then
                                                    passengers = passengers + 1
                                                end
                                                ShowNumberOnBlip(blip, passengers)
                                            else
                                                HideNumberOnBlip(blip)
                                            end
                                        else
                                            -- Se nessuno degli else per le auto viene verificato, allora setto il blip normale.
                                            HideNumberOnBlip(blip)
                                            if blipSprite ~= 1 then -- il blip default è 1
                                                SetBlipSprite(blip, 1)
                                                Citizen.InvokeNative(0x5FBCA48327B914DF, blip, true) -- Aggiunge effettivamente il blip
                                            end
                                        end
                                        SetBlipRotation(blip, math.ceil(GetEntityHeading(veh))) -- con questo aggiorno la rotazione a seconda del veicolo
                                        SetBlipNameToPlayerName(blip, i) -- aggirono il blip del giocatore
                                        SetBlipScale(blip, 0.85) -- dimensione
                                        -- se il menù con la mappa grande è aperto, allora setto il blip con un alpha massimo
                                        -- con questo poi controllo la distanza dal giocatore per il nome sulla testa
                                        if IsPauseMenuActive() then
                                            SetBlipAlpha(blip, 255)
                                        else -- se la prima non è confermata
                                            x1, y1 = table.unpack(GetEntityCoords(PlayerPedId(), true)) -- non ho messo la z perché non mi serve
                                            x2, y2 = table.unpack(GetEntityCoords(GetPlayerPed(i), true)) -- uguale qua sotto
                                            distanza = (math.floor(math.abs(math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2))) / -1)) + 900
                                            -- lo ho fatto così perché si....
                                            if distanza < 0 then
                                                distanza = 0
                                            elseif distanza > 255 then
                                                distanza = 255
                                            end
                                            SetBlipAlpha(blip, distanza)
                                        end
                                    end
                                else
                                    RemoveBlip(blip)
                                end
                            end
                        end
                    end

                    Wait(5000)
    end
end)


